Imports System
Imports System.Drawing
Imports System.IO
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports PDFTRON
Imports PDFTRON.PDF
Imports PDFTRON.Common

Public Class ExportDialog
    Inherits System.Windows.Forms.Form

    Private label1 As System.Windows.Forms.Label
    Private groupBox1 As System.Windows.Forms.GroupBox
    Private groupBox2 As System.Windows.Forms.GroupBox
    Private fromBox As System.Windows.Forms.TextBox
    Private toBox As System.Windows.Forms.TextBox
    'Private okButton As System.Windows.Forms.Button
    Private groupBox3 As System.Windows.Forms.GroupBox
    'Private browseButton As System.Windows.Forms.Button
    Private label2 As System.Windows.Forms.Label
    Private label3 As System.Windows.Forms.Label
    Private label4 As System.Windows.Forms.Label
    Private resolutionComboBox As System.Windows.Forms.ComboBox
    Private directoryTextBox As System.Windows.Forms.TextBox
    Private extensionComboBox As System.Windows.Forms.ComboBox
    Private _pdfdoc As PDFDoc
    Private components As System.ComponentModel.Container = Nothing


    Public Sub New(ByVal doc As PDFDoc)
        Me._pdfdoc = doc
        InitializeComponent()
        Me.Visible = True
        Console.Write("HI")
		toBox.Text = (Me._pdfdoc.GetPageCount).ToString
        extensionComboBox.SelectedIndex = 0
        resolutionComboBox.SelectedIndex = 0
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Private WithEvents toCancelButton As System.Windows.Forms.Button
    Private WithEvents okButton As System.Windows.Forms.Button
    Private WithEvents browseButton As System.Windows.Forms.Button

    Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(ExportDialog))
        Me.fromBox = New System.Windows.Forms.TextBox
        Me.toBox = New System.Windows.Forms.TextBox
        Me.label1 = New System.Windows.Forms.Label
        Me.groupBox1 = New System.Windows.Forms.GroupBox
        Me.label4 = New System.Windows.Forms.Label
        Me.groupBox2 = New System.Windows.Forms.GroupBox
        Me.resolutionComboBox = New System.Windows.Forms.ComboBox
        Me.okButton = New System.Windows.Forms.Button
        Me.toCancelButton = New System.Windows.Forms.Button
        Me.groupBox3 = New System.Windows.Forms.GroupBox
        Me.label3 = New System.Windows.Forms.Label
        Me.label2 = New System.Windows.Forms.Label
        Me.extensionComboBox = New System.Windows.Forms.ComboBox
        Me.browseButton = New System.Windows.Forms.Button
        Me.directoryTextBox = New System.Windows.Forms.TextBox
        Me.groupBox1.SuspendLayout()
        Me.groupBox2.SuspendLayout()
        Me.groupBox3.SuspendLayout()
        Me.SuspendLayout()
        '
        'fromBox
        '
        Me.fromBox.Location = New System.Drawing.Point(136, 24)
        Me.fromBox.Name = "fromBox"
        Me.fromBox.Size = New System.Drawing.Size(40, 22)
        Me.fromBox.TabIndex = 0
        Me.fromBox.Text = "1"
        '
        'toBox
        '
        Me.toBox.Location = New System.Drawing.Point(288, 24)
        Me.toBox.Name = "toBox"
        Me.toBox.Size = New System.Drawing.Size(40, 22)
        Me.toBox.TabIndex = 1
        Me.toBox.Text = "1"
        '
        'label1
        '
        Me.label1.Location = New System.Drawing.Point(200, 24)
        Me.label1.Name = "label1"
        Me.label1.Size = New System.Drawing.Size(64, 23)
        Me.label1.TabIndex = 2
        Me.label1.Text = "To Page"
        '
        'groupBox1
        '
        Me.groupBox1.Controls.Add(Me.label4)
        Me.groupBox1.Controls.Add(Me.toBox)
        Me.groupBox1.Controls.Add(Me.label1)
        Me.groupBox1.Controls.Add(Me.fromBox)
        Me.groupBox1.Location = New System.Drawing.Point(32, 152)
        Me.groupBox1.Name = "groupBox1"
        Me.groupBox1.Size = New System.Drawing.Size(384, 64)
        Me.groupBox1.TabIndex = 3
        Me.groupBox1.TabStop = False
        Me.groupBox1.Text = "Page Range"
        '
        'label4
        '
        Me.label4.Location = New System.Drawing.Point(32, 24)
        Me.label4.Name = "label4"
        Me.label4.Size = New System.Drawing.Size(80, 23)
        Me.label4.TabIndex = 3
        Me.label4.Text = "From Page"
        '
        'groupBox2
        '
        Me.groupBox2.Controls.Add(Me.resolutionComboBox)
        Me.groupBox2.Location = New System.Drawing.Point(32, 232)
        Me.groupBox2.Name = "groupBox2"
        Me.groupBox2.Size = New System.Drawing.Size(384, 64)
        Me.groupBox2.TabIndex = 4
        Me.groupBox2.TabStop = False
        Me.groupBox2.Text = "Image Resolution"
        '
        'resolutionComboBox
        '
        Me.resolutionComboBox.Items.AddRange(New Object() {"50 DPI", "72 DPI", "92 DPI", "200 DPI", "300 DPI"})
        Me.resolutionComboBox.Location = New System.Drawing.Point(96, 24)
        Me.resolutionComboBox.Name = "resolutionComboBox"
        Me.resolutionComboBox.Size = New System.Drawing.Size(184, 24)
        Me.resolutionComboBox.TabIndex = 0
        '
        'okButton
        '
        Me.okButton.Location = New System.Drawing.Point(120, 320)
        Me.okButton.Name = "okButton"
        Me.okButton.Size = New System.Drawing.Size(80, 23)
        Me.okButton.TabIndex = 5
        Me.okButton.Text = "OK"
        '
        'toCancelButton
        '
        Me.toCancelButton.Location = New System.Drawing.Point(248, 320)
        Me.toCancelButton.Name = "toCancelButton"
        Me.toCancelButton.Size = New System.Drawing.Size(88, 23)
        Me.toCancelButton.TabIndex = 6
        Me.toCancelButton.Text = "Cancel"
        '
        'groupBox3
        '
        Me.groupBox3.Controls.Add(Me.label3)
        Me.groupBox3.Controls.Add(Me.label2)
        Me.groupBox3.Controls.Add(Me.extensionComboBox)
        Me.groupBox3.Controls.Add(Me.browseButton)
        Me.groupBox3.Controls.Add(Me.directoryTextBox)
        Me.groupBox3.Location = New System.Drawing.Point(32, 16)
        Me.groupBox3.Name = "groupBox3"
        Me.groupBox3.Size = New System.Drawing.Size(384, 120)
        Me.groupBox3.TabIndex = 7
        Me.groupBox3.TabStop = False
        Me.groupBox3.Text = "File Information"
        '
        'label3
        '
        Me.label3.Location = New System.Drawing.Point(24, 72)
        Me.label3.Name = "label3"
        Me.label3.Size = New System.Drawing.Size(72, 23)
        Me.label3.TabIndex = 4
        Me.label3.Text = "Extension:"
        '
        'label2
        '
        Me.label2.Location = New System.Drawing.Point(24, 24)
        Me.label2.Name = "label2"
        Me.label2.TabIndex = 3
        Me.label2.Text = "Root Directory:"
        '
        'extensionComboBox
        '
        Me.extensionComboBox.Items.AddRange(New Object() {"PNG (*.png)", "TIF (*.tif)", "JPG (*.jpg)", "BMP (*.BMP)"})
        Me.extensionComboBox.Location = New System.Drawing.Point(136, 72)
        Me.extensionComboBox.Name = "extensionComboBox"
        Me.extensionComboBox.Size = New System.Drawing.Size(136, 24)
        Me.extensionComboBox.TabIndex = 2
        '
        'browseButton
        '
        Me.browseButton.Location = New System.Drawing.Point(272, 24)
        Me.browseButton.Name = "browseButton"
        Me.browseButton.TabIndex = 1
        Me.browseButton.Text = "Browse"
        '
        'directoryTextBox
        '
        Me.directoryTextBox.Location = New System.Drawing.Point(136, 24)
        Me.directoryTextBox.Name = "directoryTextBox"
        Me.directoryTextBox.Size = New System.Drawing.Size(136, 22)
        Me.directoryTextBox.TabIndex = 0
        Me.directoryTextBox.Text = ""
        '
        'ExportDialog
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 15)
        Me.ClientSize = New System.Drawing.Size(442, 368)
        Me.Controls.Add(Me.groupBox3)
        Me.Controls.Add(Me.toCancelButton)
        Me.Controls.Add(Me.okButton)
        Me.Controls.Add(Me.groupBox2)
        Me.Controls.Add(Me.groupBox1)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "ExportDialog"
        Me.Text = "Export"
        Me.groupBox1.ResumeLayout(False)
        Me.groupBox2.ResumeLayout(False)
        Me.groupBox3.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub


    Private Sub okButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles okButton.Click
        Dim rangeFailed As Boolean = False
        Dim draw As PDFDraw = New PDFDraw
        Dim dpi As String = CType(resolutionComboBox.SelectedItem, String).TrimEnd((" DPI").ToCharArray)
        draw.SetDPI(System.Convert.ToInt32(dpi, 10))
        Dim starIndex As Integer = CType(extensionComboBox.SelectedItem, String).IndexOf("*")
        Dim extension As String = CType(extensionComboBox.SelectedItem, String).Substring(starIndex + 1, 4)
        Dim toVal As Integer = 1
        Dim from As Integer = 1
        Try
            toVal = System.Convert.ToInt32(toBox.Text)
            from = System.Convert.ToInt32(fromBox.Text)
        Catch ex As FormatException
            rangeFailed = True
        End Try
		If (toVal < from) OrElse (Me._pdfdoc.GetPageCount < toVal) OrElse from < 1 Then
			rangeFailed = True
		End If
		If rangeFailed Then
			MessageBox.Show("Please Enter Valid Page Ranges")
			Return
		End If
		Dim dirPath As String = directoryTextBox.Text
		If Not Directory.Exists(dirPath) Then
			MessageBox.Show("Directory " + directoryTextBox.Text + " Does Not Exist")
			Return
		End If
		Dim i As Integer = from
		While i <= toVal
            draw.Export(_pdfdoc.GetPage(i), dirPath + "/Page" + (i).ToString + extension)
			System.Math.Min(System.Threading.Interlocked.Increment(i), i - 1)
		End While
		Me.Dispose()
    End Sub

    Private Sub browseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles browseButton.Click
        Dim dlg As FolderBrowserDialog = New FolderBrowserDialog
        Dim res As DialogResult = dlg.ShowDialog
        If res = DialogResult.OK Then
            directoryTextBox.Text = dlg.SelectedPath
        End If
    End Sub

    Private Sub cancelButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles toCancelButton.Click
        Me.Dispose()
    End Sub

End Class
